FileCleaningTracker (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io

## Class FileCleaningTracker

- java.lang.Object
- - org.apache.commons.io.FileCleaningTracker

-     public class FileCleaningTracker
      extends java.lang.Object

  Keeps track of files awaiting deletion, and deletes them when an associated marker object is reclaimed by the garbage collector.

  This utility creates a background thread to handle file deletion. Each file to be deleted is registered with a handler object. When the handler object is garbage collected, the file is deleted.

  In an environment with multiple class loaders (a servlet container, for example), you should consider stopping the background thread if it is no longer needed. This is done by invoking the method `exitWhenFinished`, typically in `javax.servlet.ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)` or similar.

  Version:
    $Id: FileCleaningTracker.java 1686747 2015-06-21 18:44:49Z krosenvold $

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private class` | `FileCleaningTracker.Reaper` The reaper thread.
    `private static class` | `FileCleaningTracker.Tracker` Inner class which acts as the reference for a file pending deletion.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) java.util.List<java.lang.String>` | `deleteFailures` Collection of File paths that failed to delete.
    `(package private) boolean` | `exitWhenFinished` Whether to terminate the thread when the tracking is complete.
    `(package private) java.lang.ref.ReferenceQueue<java.lang.Object>` | `q` Queue of `Tracker` instances being watched.
    `(package private) java.lang.Thread` | `reaper` The thread that will clean up registered files.
    `(package private) java.util.Collection<FileCleaningTracker.Tracker>` | `trackers` Collection of `Tracker` instances in existence.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FileCleaningTracker()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addTracker(java.lang.String path, java.lang.Object marker, FileDeleteStrategy deleteStrategy)` Adds a tracker to the list of trackers.
    `void` | `exitWhenFinished()` Call this method to cause the file cleaner thread to terminate when there are no more objects being tracked for deletion.
    `java.util.List<java.lang.String>` | `getDeleteFailures()` Return the file paths that failed to delete.
    `int` | `getTrackCount()` Retrieve the number of files currently being tracked, and therefore awaiting deletion.
    `void` | `track(java.io.File file, java.lang.Object marker)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
    `void` | `track(java.io.File file, java.lang.Object marker, FileDeleteStrategy deleteStrategy)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
    `void` | `track(java.lang.String path, java.lang.Object marker)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
    `void` | `track(java.lang.String path, java.lang.Object marker, FileDeleteStrategy deleteStrategy)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### q

          java.lang.ref.ReferenceQueue<java.lang.Object> q

      Queue of `Tracker` instances being watched.

    - #### trackers

          final java.util.Collection<FileCleaningTracker.Tracker> trackers

      Collection of `Tracker` instances in existence.

    - #### deleteFailures

          final java.util.List<java.lang.String> deleteFailures

      Collection of File paths that failed to delete.

    - #### exitWhenFinished

          volatile boolean exitWhenFinished

      Whether to terminate the thread when the tracking is complete.

    - #### reaper

          java.lang.Thread reaper

      The thread that will clean up registered files.

  - ### Constructor Detail

    - #### FileCleaningTracker

          public FileCleaningTracker()

  - ### Method Detail

    - #### track

          public void track(java.io.File file,
                   java.lang.Object marker)

      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.
      Parameters:
        `file` - the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
      Throws:
        `java.lang.NullPointerException` - if the file is null

    - #### track

          public void track(java.io.File file,
                   java.lang.Object marker,
                   FileDeleteStrategy deleteStrategy)

      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.
      Parameters:
        `file` - the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
        `deleteStrategy` - the strategy to delete the file, null means normal
      Throws:
        `java.lang.NullPointerException` - if the file is null

    - #### track

          public void track(java.lang.String path,
                   java.lang.Object marker)

      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.
      Parameters:
        `path` - the full path to the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
      Throws:
        `java.lang.NullPointerException` - if the path is null

    - #### track

          public void track(java.lang.String path,
                   java.lang.Object marker,
                   FileDeleteStrategy deleteStrategy)

      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.
      Parameters:
        `path` - the full path to the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
        `deleteStrategy` - the strategy to delete the file, null means normal
      Throws:
        `java.lang.NullPointerException` - if the path is null

    - #### addTracker

          private void addTracker(java.lang.String path,
                        java.lang.Object marker,
                        FileDeleteStrategy deleteStrategy)

      Adds a tracker to the list of trackers.
      Parameters:
        `path` - the full path to the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
        `deleteStrategy` - the strategy to delete the file, null means normal

    - #### getTrackCount

          public int getTrackCount()

      Retrieve the number of files currently being tracked, and therefore awaiting deletion.
      Returns:
        the number of files being tracked

    - #### getDeleteFailures

          public java.util.List<java.lang.String> getDeleteFailures()

      Return the file paths that failed to delete.
      Returns:
        the file paths that failed to delete
      Since:
        2.0

    - #### exitWhenFinished

          public void exitWhenFinished()

      Call this method to cause the file cleaner thread to terminate when there are no more objects being tracked for deletion.

      In a simple environment, you don't need this method as the file cleaner thread will simply exit when the JVM exits. In a more complex environment, with multiple class loaders (such as an application server), you should be aware that the file cleaner thread will continue running even if the class loader it was started from terminates. This can consitute a memory leak.

      For example, suppose that you have developed a web application, which contains the commons-io jar file in your WEB-INF/lib directory. In other words, the FileCleaner class is loaded through the class loader of your web application. If the web application is terminated, but the servlet container is still running, then the file cleaner thread will still exist, posing a memory leak.

      This method allows the thread to be terminated. Simply call this method in the resource cleanup code, such as `javax.servlet.ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)`. Once called, no new objects can be tracked by the file cleaner.

Copyright (c) 2002-2016 Apache Software Foundation